﻿using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem;
using SoapEndpoint.Tester.Infrastructure;
using SoapEndpoint.Tester.Models.Systeem;

namespace SoapEndpoint.Tester;

public partial class DownloadAttachmentsForm : Form
{
    private readonly MessageboxBerichtModel _messageboxBericht;
    private readonly IMessageBoxProxy _messageBoxProxy;

    public DownloadAttachmentsForm(MessageboxBerichtModel messageboxBericht, IMessageBoxProxy messageBoxProxy)
    {
        _messageboxBericht = messageboxBericht;
        _messageBoxProxy = messageBoxProxy;

        CenterToParent();

        InitializeComponent();

        SetDownloadButtons();
    }

    public void SetDownloadButtons()
    {
        foreach (var bijlagereferentienummer in _messageboxBericht.Bijlagereferentienummers)
        {
            var button = new Button();
            button.AutoSizeMode = AutoSizeMode.GrowOnly;
            button.TextAlign = ContentAlignment.MiddleCenter;
            button.Width = 200;
            button.Tag = new SelectedMessageboxBericht
            {
                Bestandreferentienummer = bijlagereferentienummer,
                Referentienummer = _messageboxBericht.Referentienummer
            };
            button.Click += DownloadAttachmentAsync;
            button.Text = bijlagereferentienummer.ToString();
            flowLayoutPanel.Controls.Add(button);
        }
    }

    public async void DownloadAttachmentAsync(object e, EventArgs args)
    {
        if (!((e as Button)?.Tag is SelectedMessageboxBericht selectedMessageBoxBericht))
        {
            return;
        }

        var downloadBijlage = new DownloadBijlageModel
        {
            Berichtreferentienummer = selectedMessageBoxBericht.Referentienummer,
            Bestandreferentienummer = selectedMessageBoxBericht.Bestandreferentienummer
        };
        var response = await _messageBoxProxy.DownloadAttachmentAsync(downloadBijlage);


        FormHelperMethods.SaveAttachment(response);
    }
}