﻿namespace SoapEndpoint.Tester.Scenario.Flow;

public abstract class FlowItemBase<TMessageType>
    where TMessageType : Enum
{
    protected FlowItemBase(
        TMessageType shvType = default,
        TMessageType shvResultMessageType = default,
        TMessageType seType = default,
        TMessageType seResultMessageType = default,
        bool shvHasAttachment = false,
        bool seHasAttachment = false)
    {
        ShvType = shvType;
        ShvResultMessageType = shvResultMessageType;
        SeType = seType;
        SeResultMessageType = seResultMessageType;
        ShvHasAttachment = shvHasAttachment;
        SeHasAttachment = seHasAttachment;
    }

    public TMessageType ShvType { get; }
    public TMessageType ShvResultMessageType { get; }

    public TMessageType SeType { get; }
    public TMessageType SeResultMessageType { get; }

    public bool ShvHasAttachment { get; }
    public bool SeHasAttachment { get; }

    public override string ToString() =>
        $"ShvType: {ShvType}, ShvResultMessageType: {ShvResultMessageType}, SeType: {SeType}, SeResultMessageType: {SeResultMessageType}";
}