﻿using SoapEndpoint.Service.Flows.BrEnHf.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.BrEnHf;

namespace SoapEndpoint.Tester.Scenario.Implementations.BrEnHf;

public class BetaalvoorstelNietAkkoordScenario : BrEnHfScenarioBase
{
    public override string Name => "Betaalvoorstel niet akkoord";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Betaalvoorstel");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordNietAkkoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Niet akkoord 1");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordNietAkkoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Niet akkoord 2");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordNietAkkoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordNietAkkoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));
    }
}