﻿using SoapEndpoint.Service.Flows.BrEnHf.v1.LogbookService;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Tester.Scenario.Flow.BrEnHf;

namespace SoapEndpoint.Tester.Scenario.Implementations.BrEnHf;

public class VoorafAkkoordScenario : BrEnHfScenarioBase
{
    public override string Name => "Vooraf akkoord Scenario";

    public override AdresboekOrganisatieModel SeOrganization =>
        Manager.Organizations.SingleOrDefault(p => p.Referentienummer.ToString()
            .Equals(Program.Configuration["SeCanAgreeInAdvanceOrganizationReference"],
                StringComparison.CurrentCultureIgnoreCase));

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Regeling geaccordeerd");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoordVoorafAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Regeling beeindigd");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoordVoorafAkkoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));
    }
}