﻿using SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Tester.Scenario.Flow.SbEnSk;

namespace SoapEndpoint.Tester.Scenario.Implementations.SbEnSk;

public class VoorafAkkoordScenario : SbEnSkScenarioBase
{
    public override string Name => "Vooraf akkoord Scenario";

    public override AdresboekOrganisatieModel SeOrganization =>
        Manager.Organizations.SingleOrDefault(p => p.Referentienummer.ToString()
            .Equals(Program.Configuration["SeCanAgreeInAdvanceOrganizationReference"],
                StringComparison.CurrentCultureIgnoreCase));

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Regeling geaccordeerd");

        // Send saldo verzoek and reply saldo verzoek antwoord
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoordVoorafAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Regeling beeindigd");

        // Send saldo verzoek and reply saldo verzoek antwoord
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoordVoorafAkkoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));
    }
}