﻿using SoapEndpoint.Service.Systeem.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.Schuldbemiddeling;

namespace SoapEndpoint.Tester.Scenario.Implementations.Schuldbemiddeling;

public class HappyFlowScenario : SchuldbemiddelingScenarioBase
{
    public override string Name => "Happy flow scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Schuldregeling geaccordeerd");

        //Happy flow with end state schuldregeling geaccordeerd
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(Berichttype.SHV_KlantGemeldVoorShv, Berichttype.SE_KlantGemeldVoorShvAntwoord),
            new ShvFlowItem(Berichttype.SHV_Saldoverzoek, Berichttype.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(Berichttype.SHV_Betaalvoorstel, Berichttype.SE_BetaalvoorstelAntwoord),
            new ShvFlowItem(Berichttype.SHV_SchuldregelingGeaccordeerd));

        StartNewScenario("Schuldregeling beeindigd");

        // Happy flow with end state schuldregeling beeindigd
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(Berichttype.SHV_KlantGemeldVoorShv, Berichttype.SE_KlantGemeldVoorShvAntwoord),
            new ShvFlowItem(Berichttype.SHV_Saldoverzoek, Berichttype.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(Berichttype.SHV_Betaalvoorstel, Berichttype.SE_BetaalvoorstelAntwoord),
            new ShvFlowItem(Berichttype.SHV_SchuldregelingBeeindigd));
    }
}