﻿using AutoMapper;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Proxy.ServiceProxies.Flows;
using SoapEndpoint.Service.Systeem.v1.LogbookService;

namespace SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v1;

public class LogbookProxy : ILogbookProxy<Berichttype>
{
    private readonly IMapper _mapper;
    private readonly ILogbookService _service;

    public LogbookProxy(IMapper mapper, ILogbookService service)
    {
        _mapper = mapper;
        _service = service;
    }

    public async Task<ConversatieLogboekBerichtModel<Berichttype>> GetConversationAsync(
        ConversatieLogboekZoekberichtModel bericht)
    {
        var request = _mapper.Map<ConversatieLogboekZoekbericht>(bericht);
        var response = await _service.GetConversationAsync(request);
        return _mapper.Map<ConversatieLogboekBerichtModel<Berichttype>>(response);
    }

    public async Task<LogboekBerichtModel<Berichttype>[]> GetMessagesAsync(LogboekZoekberichtModel bericht)
    {
        var request = _mapper.Map<LogboekZoekbericht>(bericht);
        var response = await _service.GetMessagesAsync(request);
        return _mapper.Map<LogboekBerichtModel<Berichttype>[]>(response);
    }
}